
#include "KeyRead.h"
#include "main.h"


//Globale Strucktur
STKEYTYPE gstKey;

// *******************************
STKEYTYPE * InitKey( void )
// *******************************
{
TASTATUR_DDRX_PORT	 = TASTATUR_DDRX_OUT_MSK;
TASTATUR_PORT_OUT = TASTATUR_KEYS_MSK; //0x0F PullUp
gstKey.u8KStat = 0;
return &gstKey;
};


// *******************************
STKEYTYPE * CheckKey( void )
// *******************************
{
//PORTC = gstKey.u8KStat;
	if( ((TASTATUR_PORT_IN  & TASTATUR_KEYS_MSK ) != TASTATUR_KEYS_MSK ) &&
		(gstKey.u8KStat & KEY_RELEASED)	
	)
		{
		gstKey.u8KStat &= KEY_STATCLEAR_MSK;	//Lsche Status
		gstKey.u8KStat |= KEY_PRESS_DETECT;	//setze Detect
		gstKey.u8Key = (TASTATUR_PORT_IN  & TASTATUR_KEYS_MSK );		
		gstKey.u32KEvent = gu32_Ticks;
		}

	if( (gstKey.u8KStat & KEY_PRESS_DETECT) && 
		( (TASTATUR_PORT_IN  & TASTATUR_KEYS_MSK ) != gstKey.u8Key  ) // nderungen ?
	)
		{
		gstKey.u32KEvent = gu32_Ticks;  // zeit neu merken
		gstKey.u8Key = (TASTATUR_PORT_IN  & TASTATUR_KEYS_MSK );		
		};
		

	if( (gstKey.u8KStat & KEY_PRESS_DETECT) && 
		( (gu32_Ticks - gstKey.u32KEvent) > 2 )
	)
		{
		gstKey.u8KStat = KEY_VALID;  // harte Zuweisung, nur vom hautprogramm gelscht
		}; //taste ok
// -----------------------------------------------
// Ist die Taste wieder losgelassen?
	if( ( gstKey.u8KStat == 0) && 		
		((TASTATUR_PORT_IN  & TASTATUR_KEYS_MSK ) == TASTATUR_KEYS_MSK) ) // PINA & 0x0F == 0x0F
		{		
		gstKey.u8KStat |= KEY_RELEASE_DETECT;		
		gstKey.u32KEvent = gu32_Ticks;
		};
		
if( (gstKey.u8KStat & KEY_RELEASE_DETECT) && 
		(( TASTATUR_PORT_IN  & TASTATUR_KEYS_MSK ) == TASTATUR_KEYS_MSK) &&
		( (gu32_Ticks - gstKey.u32KEvent) > 48 ) //200mS
	)
		{
		gstKey.u8KStat &= KEY_STATCLEAR_MSK;
		gstKey.u8KStat |= KEY_RELEASED;	
		};
return &gstKey;	
}	
